Imports System
Imports System.Data
Imports System.Data.OleDb

' Mtodos da classe DB que usam os procedimentos armazenados
Public Class AcessoBD
    ' verifique a localizao correta do banco de dados no seu ambiente
    Shared connectionString As String = "PROVIDER=Microsoft.Jet.OLEDB.4.0;Data Source=d:\teste\Northwind.mdb"

    ' Este mtodo retorna um dataset com todos os registros da tabela Products
    Function listarProdutos() As DataSet
        Dim con As OleDbConnection
        Dim da As OleDbDataAdapter
        Dim ds As DataSet
        Dim sSQL As String

        sSQL = "EXECUTE spListaProdutos"

        con = New OleDbConnection(connectionString)
        da = New OleDbDataAdapter(sSQL, con)
        ds = New DataSet
        da.Fill(ds, "Products")

        Return ds

    End Function

    ' Este mtodo incluir uma nova linha na tabela
    Sub incluirProdutos(ByVal ProductName As String, ByVal SupplierID As Integer, ByVal CategoryID As Integer, ByVal QuantityPerUnit As String, ByVal UnitPrice As Double, ByVal UnitsInStock As Integer, ByVal UnitsOnOrder As Integer, ByVal ReorderLevel As Integer)

        Dim con As OleDbConnection
        Dim cmd As OleDbCommand = New OleDbCommand
        Dim paramNomeProduto As New OleDbParameter
        Dim paramCodigoFornecedor As New OleDbParameter
        Dim paramCodigoCategoria As New OleDbParameter
        Dim paramQuantidade As New OleDbParameter
        Dim paramPreco As New OleDbParameter
        Dim paramEstoque As New OleDbParameter
        Dim paramPedido As New OleDbParameter
        Dim paramMinimo As New OleDbParameter

        con = New OleDbConnection(connectionString)
        cmd.Connection = con

        With paramNomeProduto
            .ParameterName = "nomeProduto"
            .OleDbType = OleDbType.VarChar
            .Size = 40
            .Value = ProductName
        End With
        cmd.Parameters.Add(paramNomeProduto)

        With paramCodigoFornecedor
            .ParameterName = "codFornecedor"
            .OleDbType = OleDbType.Integer
            .Size = 4
            .Value = SupplierID
        End With
        cmd.Parameters.Add(paramCodigoFornecedor)

        With paramCodigoCategoria
            .ParameterName = "codCategoria"
            .OleDbType = OleDbType.Integer
            .Size = 4
            .Value = CategoryID
        End With
        cmd.Parameters.Add(paramCodigoCategoria)

        With paramQuantidade
            .ParameterName = "quantidade"
            .OleDbType = OleDbType.VarChar
            .Size = 20
            .Value = QuantityPerUnit
        End With
        cmd.Parameters.Add(paramQuantidade)

        With paramPreco
            .ParameterName = "precoUnitario"
            .OleDbType = OleDbType.Currency
            '.Size =  
            .Value = UnitPrice
        End With
        cmd.Parameters.Add(paramPreco)

        With paramEstoque
            .ParameterName = "uniEstoque"
            .OleDbType = OleDbType.Integer
            .Size = 4
            .Value = UnitsInStock
        End With
        cmd.Parameters.Add(paramEstoque)

        With paramPedido
            .ParameterName = "uniPedido"
            .OleDbType = OleDbType.Integer
            .Size = 4
            .Value = UnitsOnOrder
        End With
        cmd.Parameters.Add(paramPedido)

        With paramMinimo
            .ParameterName = "nivelUnidade"
            .OleDbType = OleDbType.Integer
            .Size = 4
            .Value = ReorderLevel
        End With
        cmd.Parameters.Add(paramMinimo)

        cmd.CommandText = "EXECUTE spIncluiProduto"
        con.Open()
        cmd.ExecuteNonQuery()
        con.Close()

    End Sub

    ' Este mtodo atualiza um produto 
    Sub atualizarProdutos(ByVal ProductID As Integer, ByVal ProductName As String)
        Dim con As OleDbConnection
        Dim cmd As OleDbCommand = New OleDbCommand
        Dim paramNomeProduto As New OleDbParameter
        Dim paramCodigoProduto As New OleDbParameter

        con = New OleDbConnection(connectionString)
        cmd.Connection = con

        With paramCodigoProduto
            .ParameterName = "codigoProduto"
            .OleDbType = OleDbType.Integer
            .Size = 4
            .Value = ProductID
        End With
        cmd.Parameters.Add(paramCodigoProduto)

        With paramNomeProduto
            .ParameterName = "nomeProduto"
            .OleDbType = OleDbType.VarChar
            .Size = 40
            .Value = ProductName
        End With
        cmd.Parameters.Add(paramNomeProduto)

        cmd.CommandText = "EXECUTE spAtualizaProdutos"
        con.Open()
        cmd.ExecuteNonQuery()
        con.Close()

    End Sub

    ' Este mtodo exclui um produto
    Sub deletarProdutos(ByVal ProductID As Integer)
        Dim con As OleDbConnection
        Dim cmd As OleDbCommand = New OleDbCommand
        Dim paramCodigoProduto As New OleDbParameter

        con = New OleDbConnection(connectionString)
        cmd.Connection = con

        With paramCodigoProduto
            .ParameterName = "codigoProduto"
            .OleDbType = OleDbType.Integer
            .Size = 4
            .Value = ProductID
        End With
        cmd.Parameters.Add(paramCodigoProduto)

        cmd.CommandText = "EXECUTE spDeletaProduto"
        con.Open()
        cmd.ExecuteNonQuery()
        con.Close()

    End Sub
End Class
